#cython: language_level=3

from .capidmscolumn_float cimport *


cdef class OBIDMS_column_float(OBIDMS_column) :

    def get_item(self, line_nb, element_name):
        return obi_column_get_float_with_elt_name(self.pointer, line_nb, element_name.encode('utf-8'))


cdef class OBIDMS_column_float_read(OBIDMS_column_float) :     

    def set_item(self, line_nb, element_name, value):
        raise Exception('Column is read-only')

    def close(self):
        if obi_close_column(self.pointer) < 0 :
            raise Exception("Problem closing a column")
                        
        
cdef class OBIDMS_column_float_writable(OBIDMS_column_float) :     

    def set_item(self, line_nb, element_name, value):
        return obi_column_set_float_with_elt_name(self.pointer, line_nb, element_name.encode('utf-8'), value)

    def close(self):
        if obi_truncate_and_close_column(self.pointer) < 0 :
            raise Exception("Problem closing a column")
     
    